﻿var config = {
    userStore: new Oidc.WebStorageStateStore({ store: window.localStorage }),
    authority: "https://localhost:44325/",
    client_id: "client_id_js",
    redirect_uri: "https://localhost:44387/Home/SignIn",
    post_logout_redirect_uri: "https://localhost:44387/Home/Index",
    //response_type: "id_token token", //when add RequirePkce response_type change to code
    response_type: "code",
    scope: "openid rc.scope ApiOne ApiTwo"
};

var userManager = new Oidc.UserManager(config);

var signIn = function () {
    userManager.signinRedirect();
};

var signOut = function () {
    userManager.signoutRedirect();
};

userManager.getUser().then(user => {
    console.log("user:", user);
    if (user) {
        axios.defaults.headers.common["Authorization"] = "Bearer " + user.access_token;
    }
});

var callApi = function () {
    axios.get("https://localhost:44340/secret")
        .then(res => {
            console.log(res);
        });
};

//var refreshing = false;

var axiosConfig = error.response.config;

axios.interceptors.response.use(
    function (response) { return response; },
    function (error) {
        console.log("axios error:", error.response);
        return Promise.reject(error);
        var axiosConfig = error.response.config;
        //if error response is 401 try to refresh token
        if (error.response.status === 401) {

            console.log("axios error 401");
            if (!refreshing) {
                refreshing = true;

                //do the refresh
                return userManager.signinSilent().then(user => {
                    console.log("new user:", user);
                    //update the http request and client
                    axios.defaults.headers.common["Authorization"] = "Bearer " + user.access_token;
                    axiosConfig.headers["Authorization"] = "Bearer " + user.access_token;
                    //retry the http request
                    return axios(axiosConfig);
                });
            }

        }
        return Promise.reject(error);
    });
